#include <PA9.h>
#include "Question.h"
#include "Questionnaire.h"
#include "utils.h"
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"



Questionnaire::Questionnaire(){
    iQuestionCourrante=0;

PA_LoadSpritePal(LOWSCREEN,0,(void*)palette_Pal);
    //addQuestion(&splash,"l'invisible");

    addQuestion(&pirates,"Pirates des Caraibes");
    addQuestion(&retour,"Retour vers le futur");
    addQuestion(&highlander,"Highlander");
    addQuestion(&shrek,"Shrek");
    addQuestion(&roger,"Qui veut la peau de Roger Rabbit ?");
    addQuestion(&starwars,"La guerre des etoiles");
    addQuestion(&belleaubois,"La Belle au bois dormant");
    addQuestion(&cinquieme,"Le cinquieme element");
    addQuestion(&mask,"The Mask");
    addQuestion(&marry,"Mary Poppins");
    addQuestion(&tootsie,"Tootsie");
    addQuestion(&bellebete,"La Belle et la Bete");
    addQuestion(&indianajones,"Les aventuriers de l'Arche Perdue");
    addQuestion(&bernard,"Les aventures de Bernard et Bianca");
    addQuestion(&marriage,"Quatre mariages et un enterrement");
    addQuestion(&obrother,"O Brother");
    addQuestion(&star,"L'Attaque des clones");
    addQuestion(&basic,"Basic Instinct");
    addQuestion(&spiderman,"Spider-Man");
    addQuestion(&forrest,"Forest Gump");

}

void Questionnaire::addQuestion(void* p1,string p2){
    vQuestions.push_back(new Question(p1,p2));
}

Question* Questionnaire::current(){
        return vQuestions[iQuestionCourrante];
 }
Question* Questionnaire::next(){
    resetTextKey();
      iQuestionCourrante++;
      return current();
 }

 Question* Questionnaire::back(){
      iQuestionCourrante--;
      return current();
 }

string Questionnaire::libelleQuestion(){
    char* temp="";
    sprintf(temp,"Question : %d/%d",iQuestionCourrante+1,vQuestions.size());

    return  string(temp);
}


string Questionnaire::reponsesCorrectes(){
    char* temp="";
    u8 bonnesreponses=0;
    for(u8 i=0; i<vQuestions.size();i++){
        bonnesreponses+=vQuestions[i]->reponseOk;
    }

    sprintf(temp,"OK :  %d/%d",bonnesreponses,vQuestions.size());

    return  string(temp);
}

void Questionnaire::afficheLight(){

    PA_DeleteSprite (LOWSCREEN,backArrow);
    PA_DeleteSprite (LOWSCREEN,nextArrow);
    PA_DeleteSprite (LOWSCREEN,OK);
    PA_DeleteSprite (LOWSCREEN,NOK);


    if (iQuestionCourrante>0){
        PA_CreateSprite(LOWSCREEN, backArrow, (void*)arrow_back_Sprite, OBJ_SIZE_16X16, 	1,0,190, 0);
    }
    if (iQuestionCourrante<vQuestions.size()-1){
        PA_CreateSprite(LOWSCREEN, nextArrow, (void*)arrow_next_Sprite, OBJ_SIZE_16X16, 	1,0,210, 0);
    }

    if (current()->reponseOk==1){
          PA_CreateSprite(LOWSCREEN, OK, (void*)OK_Sprite, OBJ_SIZE_16X16, 	1,0,10, 0);
    }
    else {
          PA_CreateSprite(LOWSCREEN, NOK, (void*)NOK_Sprite, OBJ_SIZE_16X16, 	1,0,10, 0);
    }

    PA_16cClearZone(TOPSCREEN,0,145, 255, 191);
    printText(TOPSCREEN,libelleQuestion(),5,170);
    printText(TOPSCREEN,reponsesCorrectes(),150,170);
   PA_16cClearZone(LOWSCREEN,0,0, 255, 191);
    printText(LOWSCREEN,"Reponse : "+current()->reponse,5,35);



}

void Questionnaire::affiche(){
    PA_16cClearZone(LOWSCREEN,0,0, 255, 191);
    PA_16cClearZone(TOPSCREEN,0,145, 255, 191);
    current()->affiche();
    printText(TOPSCREEN,libelleQuestion(),5,170);
    printText(TOPSCREEN,reponsesCorrectes(),150,170);

    //Navigation Arrow
    PA_DeleteSprite (LOWSCREEN,backArrow);
    PA_DeleteSprite (LOWSCREEN,nextArrow);
    PA_DeleteSprite (LOWSCREEN,OK);
    PA_DeleteSprite (LOWSCREEN,NOK);



    if (iQuestionCourrante>0){
        PA_CreateSprite(LOWSCREEN, backArrow, (void*)arrow_back_Sprite, OBJ_SIZE_16X16, 	1,0,190, 0);
    }
    if (iQuestionCourrante<vQuestions.size()-1){
        PA_CreateSprite(LOWSCREEN, nextArrow, (void*)arrow_next_Sprite, OBJ_SIZE_16X16, 	1,0,210, 0);
    }

    if (current()->reponseOk==1){
          PA_CreateSprite(LOWSCREEN, OK, (void*)OK_Sprite, OBJ_SIZE_16X16, 	1,0,10, 0);
    }
    else {
          PA_CreateSprite(LOWSCREEN, NOK, (void*)NOK_Sprite, OBJ_SIZE_16X16, 	1,0,10, 0);
    }


}


